// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.2 (2006/08/13)

#include "Wm4GraphicsPCH.h"
#include "Wm4TriMesh.h"
using namespace Wm4;

WM4_IMPLEMENT_RTTI(Wm4,TriMesh,Triangles);
WM4_IMPLEMENT_STREAM(TriMesh);
WM4_IMPLEMENT_DEFAULT_STREAM(TriMesh,Triangles);
WM4_IMPLEMENT_DEFAULT_NAME_ID(TriMesh,Triangles);

//----------------------------------------------------------------------------
TriMesh::TriMesh ()
{
    Type = GT_TRIMESH;
}
//----------------------------------------------------------------------------
TriMesh::TriMesh (VertexBuffer* pkVBuffer, IndexBuffer* pkIBuffer)
    :
    Triangles(pkVBuffer,pkIBuffer)
{
    Type = GT_TRIMESH;
    UpdateModelNormals();
}
//----------------------------------------------------------------------------
TriMesh::~TriMesh ()
{
}
//----------------------------------------------------------------------------
bool TriMesh::GetTriangle (int i, int& riV0, int& riV1, int& riV2) const
{
    if (0 <= i && i < GetTriangleQuantity())
    {
        const int* piIndex = &IBuffer->GetData()[3*i];
        riV0 = *piIndex++;
        riV1 = *piIndex++;
        riV2 = *piIndex;
        return true;
    }
    return false;
}
//----------------------------------------------------------------------------
